'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ControllerBase = {
  create: function create(request, response) {
    var _this = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      var doc, saved;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              doc = new _this.model(request.body);
              _context.next = 4;
              return doc.save();

            case 4:
              saved = _context.sent;
              return _context.abrupt('return', response.status(201).json(saved));

            case 8:
              _context.prev = 8;
              _context.t0 = _context['catch'](0);
              return _context.abrupt('return', response.status(_this.getErrorStatus(_context.t0)).send({ message: 'Server error', error: _context.t0 }));

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this, [[0, 8]]);
    }))();
  },
  find: function find(request, response) {
    var _this2 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
      var _result, result;

      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _result = {};
              _context2.t0 = _defineProperty3.default;
              _context2.t1 = _result;
              _context2.t2 = _this2.model.collection.collectionName.toLowerCase();
              _context2.next = 7;
              return _this2.model.find();

            case 7:
              _context2.t3 = _context2.sent;
              (0, _context2.t0)(_context2.t1, _context2.t2, _context2.t3);
              _context2.t4 = _defineProperty3.default;
              _context2.t5 = _result;
              _context2.next = 13;
              return _this2.model.count();

            case 13:
              _context2.t6 = _context2.sent;
              _context2.t7 = {
                total: _context2.t6
              };
              (0, _context2.t4)(_context2.t5, 'metadata', _context2.t7);
              result = _result;
              return _context2.abrupt('return', response.status(200).json(result));

            case 20:
              _context2.prev = 20;
              _context2.t8 = _context2['catch'](0);
              return _context2.abrupt('return', response.status(500).send({ message: 'Server error', error: _context2.t8 }));

            case 23:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this2, [[0, 20]]);
    }))();
  },
  findById: function findById(request, response) {
    var _this3 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      var doc;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return _this3.model.findById(request.params.id);

            case 3:
              doc = _context3.sent;
              return _context3.abrupt('return', response.status(200).json(doc));

            case 7:
              _context3.prev = 7;
              _context3.t0 = _context3['catch'](0);
              return _context3.abrupt('return', response.status(500).send({ message: 'Server error', error: _context3.t0 }));

            case 10:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, _this3, [[0, 7]]);
    }))();
  },
  update: function update(request, response) {
    var _this4 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      var query, update, doc;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.prev = 0;
              query = { _id: request.params.id };
              update = request.body;
              _context4.next = 5;
              return _this4.model.findOneAndUpdate(query, update, { new: true });

            case 5:
              doc = _context4.sent;

              if (doc) {
                _context4.next = 8;
                break;
              }

              return _context4.abrupt('return', response.status(404).json({ message: 'Not found' }));

            case 8:
              return _context4.abrupt('return', response.status(200).json(doc));

            case 11:
              _context4.prev = 11;
              _context4.t0 = _context4['catch'](0);
              return _context4.abrupt('return', response.status(500).send({ message: 'Server error', error: _context4.t0 }));

            case 14:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, _this4, [[0, 11]]);
    }))();
  },
  remove: function remove(request, response) {
    var _this5 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
      var doc;
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.prev = 0;
              _context5.next = 3;
              return _this5.model.findOneAndRemove({ _id: request.params.id });

            case 3:
              doc = _context5.sent;

              if (doc) {
                _context5.next = 6;
                break;
              }

              return _context5.abrupt('return', response.status(404).json({ message: 'Not found' }));

            case 6:
              return _context5.abrupt('return', response.status(200).json((0, _defineProperty3.default)({}, _this5.model.modelName.toLowerCase(), doc._id)));

            case 9:
              _context5.prev = 9;
              _context5.t0 = _context5['catch'](0);
              return _context5.abrupt('return', response.status(500).send({ message: 'Server error', error: _context5.t0 }));

            case 12:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, _this5, [[0, 9]]);
    }))();
  },
  getErrorStatus: function getErrorStatus(error) {
    return error.name === 'ValidationError' ? 400 : 500;
  }
};

module.exports = { ControllerBase: ControllerBase };