'use strict';

var _getOwnPropertyNames = require('babel-runtime/core-js/object/get-own-property-names');

var _getOwnPropertyNames2 = _interopRequireDefault(_getOwnPropertyNames);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./controller-base'),
    ControllerBase = _require.ControllerBase;

var _require2 = require('./controller'),
    Controller = _require2.Controller;

var ControllerFactory = function () {
  function ControllerFactory() {
    (0, _classCallCheck3.default)(this, ControllerFactory);

    throw new Error('ControllerFactory includes only static methods and does not need to be instantiated'); // eslint-disable-line
  }

  (0, _createClass3.default)(ControllerFactory, null, [{
    key: 'getControllerFor',
    value: function getControllerFor(model) {
      var overrides = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ControllerBase;

      if (!model) {
        throw new Error('Can\'t instantiate controller for model \'' + model + '\'');
      }

      var controller = new Controller(model);
      this.setControllerInterface(controller, base, overrides);
      this.autoBind(controller);

      return controller;
    }
  }, {
    key: 'setControllerInterface',
    value: function setControllerInterface(controller, base, overrides) {
      if (!(controller instanceof Controller)) {
        throw new Error('Object provided is not a Controller instance');
      }
      var proto = (0, _getPrototypeOf2.default)(controller);

      var mixin = (0, _extends3.default)({}, base, overrides);

      (0, _keys2.default)(mixin).forEach(function (method) {
        proto[method] = mixin[method];
      });
    }
  }, {
    key: 'autoBind',
    value: function autoBind(controller) {
      var proto = (0, _getPrototypeOf2.default)(controller);
      var propertyNames = (0, _getOwnPropertyNames2.default)(proto);

      propertyNames.forEach(function (name) {
        var propertyValue = proto[name];

        if (name === 'constructor') {
          return;
        }

        if (typeof propertyValue === 'function') {
          proto[name] = proto[name].bind(controller);
        }
      });
    }
  }]);
  return ControllerFactory;
}();

module.exports = ControllerFactory;